{ IRC (c) 2001 by Master-Soft
  Coded by TheMaster
  http://www.Master-Soft.de
}

unit IRC;

interface

uses SysUtils;

Function LogonText(NickName, Ident,RealName:String):String; // Gibt den AnmeldeString fr den IRC Server zurck
Function IdentText(ReceiveText,OS,UserID:String):String; // Gibt den String des Ident Servers zurck
Function Ping(ReceiveText:String):Boolean; // berprft, ob eine Ping-Anfrage vorliegt
Function Pong(ReceiveText:String):String; // Gibt den zurckzugebenden Pong-Befehl zurck
Function GetAction(ReceiveText:String):String; // Gibt die IRC-Aktion/Nummer zurck
Function QuitIRC(Msg:String):String; // Gibt den Quit-String zurck
Function JoinChannel(Channel:String):String; // Gibt den Join-String zurck
Function JoinChannelPW(Channel, Password:String):String; // Gibt den Join-String mit Passwort zurck
Function PartChannel(Channel,Msg:String):String; // Gibt den part-String zurck
Function GetPerson(ReceiveText:String):String; // Gibt den Namen des Aktion-Auslsenden zurck
Function GetTarget(ReceiveText:String):String; // Gibt das Ziel (Channel/Nick) der Aktion zurck
Function GetTarget2(ReceiveText:String):String; // Gibt das Wort hinter dem Ziel (Channel/Nick) der Aktion zurck
Function GetTarget3(ReceiveText:String):String; // Gibt das zweite Wort hinter dem Ziel (Channel/Nick) der Aktion zurck
Function PrivMsg(Target, Msg:String):String; // Gibt den String fr eine Private Nachticht an Channel/User zurck
Function Notice(Target, Msg:String):String; // Gibt den String fr ein Notice Nachticht an Channel/User zurck
Function GetMessage(ReceiveText:String):String; // Gibt die Nachricht zurck
Function GetFirstCom(ReceiveText:String):String; // Gibt das erste Command der Nachricht zurck
Function GetSecondCom(ReceiveText:String; TillEnd:Boolean):String; // Gibt das zweite Command der Nachricht zurck
Function GetThirdCom(ReceiveText:String; TillEnd:Boolean):String; // Gibt das dritte Command der Nachricht zurck
Function ServerCommand(Command:String):String; // Gibt den String fr ein direktes Serverkommando zurck
Function SetMode(Channel,Mode,Target:String):String; // Gibt den String fr das Setzten von Channel-Modes zurck
Function SetTopic(Channel,Topic:String):String; // Gibt den String fr das Setzten von Topics zurck
Function CTCP(Target,Command:String):String; // Gibt das CTCP Command zurck
Function Kick(Channel,Nickname,Msg:String):String; // Gibt den Command zum kicken zurck
Function Invite(Nickname,Channel:String):String; // Gibt den Command zum Inviten eines Users in einen Channel zurck
Function GetIPPart(IP:String;Nr:Integer):Integer; // Gibt den gewnschten Teil einer IP-Adresse zurck
Function DecodeIP(LongIP:LongWord):String; // Convertiert eine LongIP zu einer ShortIP
Function EncodeIP(ShortIP:String):LongWord;  // Convertiert eine ShortIP zu einer LongIP


implementation

Function LogonText(NickName,Ident,RealName:String):String;
begin
  Result := 'NICK ' + NickName + #10 + 'USER ' + Ident + ' 0 0 :' + RealName + #10;
end;

Function Kick(Channel,NickName,Msg:String):String;
begin
  Result := 'KICK ' + Channel + ' ' + NickName + ' :' + Msg + #10;
end;

Function IdentText(ReceiveText,OS,UserID:String):String;
begin
  Result := ReceiveText + ' : USERID : ' + OS + ' : ' + UserID + #10;
end;

Function Ping(ReceiveText:String):Boolean;
begin
  if Copy(ReceiveText, 1, 4) = 'PING' then Result := TRUE
  else Result := FALSE;
end;

Function Pong(ReceiveText:String):String;
begin
  Result := 'PONG ' + Copy(ReceiveText, 7, Length(ReceiveText)-6) + #10;
end;

Function GetAction(ReceiveText:String):String;
var i, i2 : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 1 to Length(ReceiveText) do
        if ReceiveText[i] = ' ' then
          for i2 := i+1 to Length(ReceiveText) do
            if ReceiveText[i2] = ' ' then
            begin
              Result := Copy(ReceiveText, i+1, i2-i-1);
              Exit;
            end;
end;

Function QuitIRC(Msg:String):String;
begin
  Result := 'QUIT :' + Msg + #10;
end;

Function JoinChannel(Channel:String):String;
begin
  Result := 'JOIN ' + Channel + #10;
end;

Function JoinChannelPW(Channel, Password:String):String;
begin
  Result := 'JOIN ' + Channel + ' ' + Password+ #10;
end;

Function PartChannel(Channel,Msg:String):String;
begin
  Result := 'PART ' + Channel + ' :' + Msg + #10;
end;

Function GetPerson(ReceiveText:String):String;
var i : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 2 to Length(ReceiveText) do
        if ReceiveText[i] = '!' then
        begin
          Result := Copy(ReceiveText, 2, i-2);
          Exit;
        end;
end;

Function GetTarget(ReceiveText:String):String;
var i, i2, i3 : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 1 to Length(ReceiveText) do
        if ReceiveText[i] = ' ' then
          for i2 := i+1 to Length(ReceiveText) do
            if ReceiveText[i2] = ' ' then
              for i3 := i2+1 to Length(ReceiveText) do
                if ReceiveText[i3] = ' ' then
                begin
                  Result := Copy(ReceiveText, i2+1, i3-i2-1);
                  Exit;
                end;
end;

Function GetTarget2(ReceiveText:String):String;
var i, i2, i3, i4 : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 1 to Length(ReceiveText) do
        if ReceiveText[i] = ' ' then
          for i2 := i+1 to Length(ReceiveText) do
            if ReceiveText[i2] = ' ' then
              for i3 := i2+1 to Length(ReceiveText) do
                if ReceiveText[i3] = ' ' then
                  for i4 := i3+1 to Length(ReceiveText) do
                    if ReceiveText[i4] = ' ' then
                    begin
                      Result := Copy(ReceiveText, i3+1, i4-i3-1);
                      Exit;
                    end;
end;

Function GetTarget3(ReceiveText:String):String;
var i, i2, i3, i4, i5 : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 1 to Length(ReceiveText) do
        if ReceiveText[i] = ' ' then
          for i2 := i+1 to Length(ReceiveText) do
            if ReceiveText[i2] = ' ' then
              for i3 := i2+1 to Length(ReceiveText) do
                if ReceiveText[i3] = ' ' then
                  for i4 := i3+1 to Length(ReceiveText) do
                    if ReceiveText[i4] = ' ' then
                      for i5 := i4+1 to Length(ReceiveText) do
                        if ReceiveText[i5] = ' ' then
                        begin
                          Result := Copy(ReceiveText, i4+1, i5-i4-1);
                          Exit;
                        end;
end;

Function PrivMsg(Target, Msg:String):String;
begin
  Result := 'PRIVMSG ' + Target + ' :' + Msg + #10;
end;

Function Notice(Target, Msg:String):String;
begin
  Result := 'NOTICE ' + Target + ' :' + Msg + #10;
end;

Function CTCP(Target, Command:String):String;
begin
  Result := 'PRIVMSG ' + Target + ' :' + Command + '' + #10;
end;

Function GetMessage(ReceiveText:String):String;
var i : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
    begin
      Result := Copy(ReceiveText, i+1, Length(ReceiveText)-i);
      Exit;
    end;
end;

Function GetFirstCom(ReceiveText:String):String;
var i, i2 : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
      for i2 := i to Length(ReceiveText) do
        if (ReceiveText[i2+1] = ' ') or (i2 = Length(ReceiveText)) then
        begin
          Result := Copy(ReceiveText, i+1, i2-i);
          Exit;
        end;
end;

Function GetSecondCom(ReceiveText:String; TillEnd:Boolean):String;
var i, i2, i3 : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
      for i2 := i to Length(ReceiveText) do
        if ReceiveText[i2] = ' ' then
          if TillEnd then
          begin
            Result := Copy(ReceiveText, i2+1, Length(ReceiveText)-i2);
            Exit;
          end else
            for i3 := i2+1 to Length(ReceiveText) do
              if (ReceiveText[i3+1] = ' ') or (i3 = Length(ReceiveText)) then
              begin
                Result := Copy(ReceiveText, i2+1, i3-i2);
                Exit;
              end;
end;

Function GetThirdCom(ReceiveText:String; TillEnd:Boolean):String;
var i, i2, i3, i4 : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
      for i2 := i to Length(ReceiveText) do
        if ReceiveText[i2] = ' ' then
          for i3 := i2+1 to Length(ReceiveText) do
            if ReceiveText[i3] = ' ' then
              if TillEnd then
              begin
                Result := Copy(ReceiveText, i3+1, Length(ReceiveText)-i3);
                Exit;
              end else
                for i4 := i3+1 to Length(ReceiveText) do
                  if (ReceiveText[i4+1] = ' ') or (i4 = Length(ReceiveText)) then
                  begin
                    Result := Copy(ReceiveText, i3+1, i4-i3);
                    Exit;
                  end;
end;

Function ServerCommand(Command:String):String;
begin
  Result := Command + #10;
end;

Function SetMode(Channel,Mode,Target:String):String;
begin
  Result := 'MODE ' + Channel + ' ' + Mode + ' ' + Target + #10;
end;

Function SetTopic(Channel,Topic:String):String;
begin
  Result := 'TOPIC ' + Channel + ' :' + Topic + #10;
end;

Function Invite(NickName, Channel:String):String;
begin
  Result := 'INVITE ' + NickName + ' ' + Channel + #10;
end;

Function GetIPPart(IP:String;Nr:Integer):Integer;
var A, B, Part: Integer;
begin
  Result := 0;
  Part := 0;
  A := 1;
  for B := 1 to Length(IP) do
  begin
    if IP[B] = '.' then
    begin
      Inc(Part);
      If Nr = Part then
      begin
        Result := StrToInt(Copy(IP, A, B-A));
        Exit;
      end else A := B+1;
    end;
    if B = Length(IP) then
    begin
      Inc(Part);
      If Nr = Part then
      begin
        Result := StrToInt(Copy(IP, A, B-A+1));
        Exit;
      end else A := B+1;
    end;
  end;
end;

Function EncodeIP(ShortIP:String):LongWord;
var a, b, c, d: Integer;
begin
  a := GetIPPart(ShortIP, 1);  b := GetIPPart(ShortIP, 2);
  c := GetIPPart(ShortIP, 3);  d := GetIPPart(ShortIP, 4);
  Result := a * 256*256*256 + b * 256*256 + c * 256 + d;
end;

Function DecodeIP(LongIP:LongWord):String;
var Temp: LongWord;
begin
  Result := '';
  Temp := LongIP div (256*256*256);
  LongIP := LongIP - (256*256*256*Temp);
  Result := IntToStr(Temp) + '.';
  Temp := LongIP div (256*256);
  LongIP := LongIP - (256*256*Temp);
  Result := Result + IntToStr(Temp) + '.';
  Temp := LongIP div (256);
  LongIP := LongIP - (256*Temp);
  Result := Result + IntToStr(Temp) + '.';
  Result := Result + IntToStr(LongIP);
end;

end.
