unit IRCOptions_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, INIFiles;

type
  TIRCOptionsForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    IRCServerComboBox: TComboBox;
    Label2: TLabel;
    IRCPortEdit: TEdit;
    CancelButton: TButton;
    ApplyButton: TButton;
    Label3: TLabel;
    ComChannelEdit: TEdit;
    Label4: TLabel;
    BotNickEdit: TEdit;
    procedure FormShow(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  IRCOptionsForm: TIRCOptionsForm;

implementation

uses MainForm_Unit;

{$R *.dfm}

procedure TIRCOptionsForm.FormShow(Sender: TObject);
var INI: TINIFile;
begin
  IRCServerComboBox.ItemIndex := 0;
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  IRCServerComboBox.Text := INI.ReadString('IRC', 'Server', 'irc.freenet.de');
  IRCPortEdit.Text := INI.ReadString('IRC', 'Port', '6667');
  ComChannelEdit.Text := INI.ReadString('IRC', 'CommandoChannel', '#BotCommand');
  BotNickEdit.Text := INI.ReadString('IRC', 'BotNick', INI.ReadString('PersonData', 'PreName', 'LaberBot'));
  INI.Free;
end;

procedure TIRCOptionsForm.CancelButtonClick(Sender: TObject);
begin
  Close();
end;

procedure TIRCOptionsForm.ApplyButtonClick(Sender: TObject);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  INI.WriteString('IRC', 'Server', IRCServerComboBox.Text);
  INI.WriteString('IRC', 'Port', IRCPortEdit.Text);
  INI.WriteString('IRC', 'CommandoChannel', ComChannelEdit.Text);
  INI.WriteString('IRC', 'BotNick', BotNickEdit.Text);
  INI.Free;
  Close();
end;

end.
