unit MainForm_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, StdCtrls, ExtCtrls, ScktComp, IRC, INIFiles,
  IdBaseComponent, IdComponent, IdUDPBase, IdUDPClient, NMUDP;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Programm1: TMenuItem;
    Beenden1: TMenuItem;
    Profil1: TMenuItem;
    StatusBar1: TStatusBar;
    Einstellungen1: TMenuItem;
    Allgemein1: TMenuItem;
    Panel1: TPanel;
    OnlineButton: TButton;
    OfflineButton: TButton;
    QuitButton: TButton;
    IRC1: TMenuItem;
    Personendaten1: TMenuItem;
    Info1: TMenuItem;
    IRCClient: TClientSocket;
    LogMemo: TMemo;
    SendEdit: TEdit;
    DenyListBox: TListBox;
    ServerSendEdit: TEdit;
    IdentServer: TServerSocket;
    DCCClient: TClientSocket;
    DCCServer: TServerSocket;
    ListBox1: TListBox;
    procedure Beenden1Click(Sender: TObject);
    procedure Profil1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Allgemein1Click(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure IRC1Click(Sender: TObject);
    procedure Personendaten1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure IdentServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure IRCClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure IRCClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnlineButtonClick(Sender: TObject);
    procedure OfflineButtonClick(Sender: TObject);
    procedure SendEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ServerSendEditKeyPress(Sender: TObject; var Key: Char);
    procedure DCCClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure DCCServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure DCCServerClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

procedure AddUser(Nick:String);
procedure DelUser(Nick:String);
procedure Delay(MSeconds : Longint);
procedure TextReceived(index:String);
function Denied(Nick:String):Boolean;
function CountComs(Index:String):Integer;
function GetComNr(Index:String;Nr:Integer):String;
function Talk(Input:String):String;
function GetItems(Index:String):Integer;
function GetItemNr(Index:String;Nr:Integer):String;
function CountSentences(Index:String):Integer;
function GetSentence(Index:String;Nr:Integer):String;
function TransForm(Index:String):String;

var
  MainForm: TMainForm;
  HomeDir, Profile: String;
  DCCGet: LongWord;

const
  Version = '0.10 BETA';

implementation

uses ProfileForm_Unit, GeneralOptionsForm_Unit,
  PersonalDataOptionsForm_Unit, IRCOptions_Unit, InfoForm_Unit;

{$R *.dfm}

procedure TMainForm.Beenden1Click(Sender: TObject);
begin
  Close();
end;

procedure TMainForm.Profil1Click(Sender: TObject);
begin
  ProfileForm.ShowModal;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  HomeDir := GetCurrentDir;
  Profile := '';
  StatusBar1.Panels[0].Text := 'Profil: [kein Profil geladen ...]';
end;

procedure TMainForm.Allgemein1Click(Sender: TObject);
begin
  GeneralOptionsForm.ShowModal;
end;

procedure TMainForm.QuitButtonClick(Sender: TObject);
begin
  Close();
end;

procedure TMainForm.IRC1Click(Sender: TObject);
begin
  IRCOptionsForm.ShowModal;
end;

procedure TMainForm.Personendaten1Click(Sender: TObject);
begin
  PersonDataOptionsForm.ShowModal;
end;

procedure TMainForm.Info1Click(Sender: TObject);
begin
  InfoForm.ShowModal;
end;

procedure TMainForm.IdentServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  IdentServer.Socket.Connections[0].SendText(IdentText(IdentServer.Socket.Connections[0].ReceiveText, 'UNIX', INI.ReadString('PersonData', 'PreName', 'Laber-B0T')));
  INI.Free;
end;

procedure TMainForm.IRCClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  IRCClient.Socket.SendText(LogonText(INI.ReadString('IRC', 'BotNick', '[]B0T[]'), INI.ReadString('PersonData', 'PreName', 'Laber-B0T'), INI.ReadString('PersonData', 'PreName', 'Laber') + ' ' + INI.ReadString('PersonData', 'LastName', 'B0T')));
  INI.Free;
end;

procedure TMainForm.IRCClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var index: String;
    i, i2 : Integer;
begin
  index := IRCClient.Socket.ReceiveText;
  for i := 1 to Length(index) do
    if (index[i-1] = #10) or (i = 1) then
      for i2 := i+1 to Length(index) do
        if index[i2] = #10 then
        begin
          TextReceived(Copy(index, i, i2-i-1));
          break;
        end;
end;

function GetSentence(Index:String;Nr:Integer):String;
var i, PosA, Count: Integer;
begin
  Result := '';
  Count := -1;
  PosA := 1;
  for i := 1 to Length(Index) do
  begin
    if Index[i] = '|' then
    begin
      Inc(Count);
      if Nr = Count then
      begin
        Result := Copy(Index, PosA, i-PosA);
        Exit;
      end else PosA := i+1;
    end;
    if i = Length(Index) then
    begin
      Inc(Count);
      if Nr = Count then
      begin
        Result := Copy(Index, PosA, i-PosA+1);
        Exit;
      end else PosA := i+1;
    end;
  end;
end;

function GetItems(Index:String):Integer;
var count, i: Integer;
begin
  count := 1;
  for i := 1 to Length(Index) do if Index[i] = '|' then Inc(Count);
  Result := Count;
end;

function GetItemNr(Index:String;Nr:Integer):String;
var PosA, PosB, i, Pos: Integer;
begin
  PosA := 1;
  Pos := 0;
  for i := 1 to Length(Index) do
  begin
    if Index[i] = '|'  then
    begin
      Inc(Pos);
      if Pos = Nr then
      begin
        PosB := i;
        Result := Copy(Index, PosA, PosB-PosA);
        Exit;
      end else PosA := i+1;
    end;
    if i = Length(Index) then
    begin
      Inc(Pos);
      if Pos = Nr then
      begin
        PosB := i;
        Result := Copy(Index, PosA, PosB-PosA+1);
        Exit;
      end else PosA := i+1;
    end;
  end;
end;

function FindIt(Index,Part:String):Boolean;
var i: Integer;
begin
  Result := FALSE;
  for i := 1 to Length(Index) do
    if AnsiLowerCase(Copy(Index, i, Length(Part))) = AnsiLowerCase(Part) then Result := TRUE;
end;

function TransForm(Index:String):String;
var i: Integer;
    INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  Result := '';
  for i := Length(Index) downto 1 do
  begin
    if Copy(Index, i, Length('<location>')) = '<location>' then
    begin
      Delete(Index, i, Length('<location>'));
      Insert(INI.ReadString('PersonData', 'Location', 'IRC'), Index, i);
    end;
    if Copy(Index, i, Length('<sex>')) = '<sex>' then
    begin
      Delete(Index, i, Length('<sex>'));
      if INI.ReadString('PersonData', 'Sex', '0') = '0' then Insert('mnnlich', Index, i) else Insert('weiblich', Index, i);
    end;
    if Copy(Index, i, Length('<age>')) = '<age>' then
    begin
      Delete(Index, i, Length('<age>'));
      Insert(INI.ReadString('PersonData', 'Age', '18'), Index, i);
    end;
    if Copy(Index, i, Length('<haircolor>')) = '<haircolor>' then
    begin
      Delete(Index, i, Length('<haircolor>'));
      Insert(INI.ReadString('PersonData', 'HairColor', 'blond'), Index, i);
    end;
    if Copy(Index, i, Length('<eyecolor>')) = '<eyecolor>' then
    begin
      Delete(Index, i, Length('<eyecolor>'));
      Insert(INI.ReadString('PersonData', 'EyeColor', 'blau'), Index, i);
    end;
    if Copy(Index, i, Length('<figure>')) = '<figure>' then
    begin
      Delete(Index, i, Length('<figure>'));
      Insert(INI.ReadString('PersonData', 'Figure', 'schlank'), Index, i);
    end;
    if Copy(Index, i, Length('<size>')) = '<size>' then
    begin
      Delete(Index, i, Length('<size>'));
      Insert(INI.ReadString('PersonData', 'Size', '1,70'), Index, i);
    end;
    if Copy(Index, i, Length('<weight>')) = '<weight>' then
    begin
      Delete(Index, i, Length('<weight>'));
      Insert(INI.ReadString('PersonData', 'Weight', '65'), Index, i);
    end;
    if Copy(Index, i, Length('<prename>')) = '<prename>' then
    begin
      Delete(Index, i, Length('<prename>'));
      Insert(INI.ReadString('PersonData', 'PreName', 'Laber'), Index, i);
    end;
    if Copy(Index, i, Length('<hobbies>')) = '<hobbies>' then
    begin
      Delete(Index, i, Length('<hobbies>'));
      Insert(INI.ReadString('PersonData', 'Hobbies', 'lesen, tanzen, disco, freunde und compuer'), Index, i);
    end;
    if Index = '<picture>' then
      Index := INI.ReadString('PersonData', 'Picture', '');
  end;
  INI.Free;
  Result := Index;
end;

function GetWordNr(Index:String;Nr:Integer):String;
var i, A, Count: Integer;
begin
  Result := '';
  Count := 0;
  A := 1;
  Index := Index + ' ';
  for i := 1 to Length(Index) do
    if Index[i] = ' ' then
    begin
      Inc(Count);
      if Nr = Count then
      begin
        Result := Copy(Index, A, i-A);
        Exit;
      end else A := i + 1;
    end;


end;

function Talk(Input:String):String;
const Get_Greetings = 'hiiii|hoi|hi|hallo|huhu|hallchen|moin|moinsen|hiho|greetz|hey|hy|servus|gude|nabend|hello|tach';
      Get_Bye = 'bye|cu|cya|tsch|tschss|tschs|tsch|tschssi|ciao';
      Smily_Good = ':)|;)|:-)|:o)|:D|:P|:>|:]|;>|;D|;P';
      Send_Greetings = 'huhu :)|na du :P|hiho|hi :)|hoi ...|moin :D|moinsen :D|tach :P';
      Send_HowAreYou = 'mir geht''s suuuper und dir ?? :D|gut und dir?|sehr gut und dir? :)|supi und selber? :>';
      Send_Location = 'ich wohne im wunderschnen <location> :P|<location>|bin aus <location>|ich wohne in <location>|ich komme aus <location>';
      Send_Bye = 'bye bye :)|tschsssi :)|tsch :>|tschss|cu|cya|bye|bis denn|bis dann';
      Send_DontUnderstand = 'h?|uhm?|was meinst?|wie meinste das?|ich versteh nich ...|kapier ich nicht ...|ich wei nicht, was du meinst|h?|keine ahnung was du meinst ...|*nixkapier*|wie bitte?|???';
      Send_asl = 'ich bin <age>, <sex> und komme aus <location>|ich bin <sex>, <age> jahre jung und wohne in <location>|ich komme aus <location>, bin <age> und <sex>|ich wohne in <location> bin <sex> und <age> jahre alt :)';
      Send_Age = 'ich bin <age> jahre jung :>|ich bin <age> ;)|ich bin <age> jahre alt ...|bin <age> .. :)';
      Send_WantFuck = 'jaaaaa klar! =)|wer will das nicht? :)|immer doch !!!|au jaa :>|jaaa, lass ficken!!|also auf sex htt ich auch bock? *grins*';
      Send_Description1 = 'ich bin <size>m gro, hab <haircolor>e haare, <eyecolor>e augen und bin <figure>|ich bin <haircolor>, <size>m klein :P, habe eine <figure>e figur und <eyecolor>e augen :)|ich bin <figure>, <size>m, <haircolor>e haare, <eyecolor>e augen :)';
      Send_Description2 = '|ich habe <eyecolor>e augen dazu <haircolor>e haare, bin <figure> und <size>m gro';
      Send_Size = 'ich bin <size>m|ich bin <size>m gro|ich bin <size>m klein :P';
      Send_Weight = 'ich wiege <weight>kg|ich bin <weight>kg schwer|ich bin <weight>kg leicht :>';
      Send_PreName = 'ich heie <prename> *grins*|ich bin die <prename> *grins*';
      Send_NoPic = 'nee, leider net :( ... hast du ?|hab leider keins :< ... du?|sorry, ich hab keins, hast du?|nee, leider nicht ... du?|hab keins ;( ... hast du?';
      Send_YesPic = 'ja .. *kram* .. schick mir mal auch eins von dir bitte :))|ich schick eins, moment... hast du auch eins? ;)|warte, ich schick eins, kannst du mir eins von dir schicken?|warte kurz :)) .. hast du auch eins von dir fr mich? ;))';
      Send_NoJoke = 'warum sollte ich dich verarschen wollen?|wieso verarsch ich dich?|ich rede bestimmt nicht mit dir um dich zu verarschen ...|wieso sollte ich das wollen?';
      Send_WantTo = 'doch! na klar will ich!! :>|hey, ich will doch!|doch ich will ... :>|ich will doch ...';
      Send_Agree = 'ok|ok ... :>|nagut|ok, wie du willst ...|nagut, wenn du meinst ... :>|alles klar';
      Send_Thema = 'hm, keine ahnung ... :>|schlag du lieber was vor :))|mir fllt nix ein :(|hm ... *grbel*';
      Send_Yes = 'ja!|jooo :>|jowohl ... :)|japp ;)|jepp :>|yo|jupp :>';
      Send_Stupid = 'warum? *wein*|warum bin ich dumm? *wein*|wieso bin ich dumm ?! bist du dumm ?!?|warum sagst du sowas? *heul*|was soll das? beschimpf ich dich?!|*wein*';
      Send_Thx = 'danke! *grins*|danke schn :P|danke ... :))';
      Send_Hobbies = 'ich mache gern: <hobbies> :>|<hobbies> mach ich gern :>|in meiner freizeit tu ich gern <hobbies>|meine hobbies *gg* -> <hobbies>';
      Send_WhyNotUnderstand = 'vielleicht drckst du dich einfach schlecht aus ... :>|vielleicht bin ich einfach zu dumm dazu ;(|vielleicht bin ich einfach zu bld ;(|weil du dich schlecht ausdrckst ... :>';
      Send_WhyForget = 'warum soll ich das vergessen?|wieso sollte ich das vergessen?|warum denn vergessen?';
      Send_WhyAss = 'warum beschimpfst du micht? *wein*|hey, lass die beleidigungen bitte !!|man was soll das ?!? ;<|lass das doch mal !!|selber du ... *grrr* ;((|*wein*';
      Send_Alone = 'jupp, bin ganz allein :>|jaaa, gaaanz aleine :P|jepp, keiner auer mir zu hause *grins*|jupp, <prename> allein zu haus *grins*';
      Send_OftenHere = 'jupp, bin sehr oft hier :>|nee, bin zum ersten mal hier :))|bin regelmig hier, immer wenn ich zeit habe :>|bin relativ oft hier *grins* :>';
var Kind, Wort, Final: String;
    i, x: Integer;
    Pic: File of Byte;
begin
  Result := '';
  Final := '';
  Kind := '';
  Randomize;
  for x := 1 to CountComs(Input) do
  begin
    Wort := GetComNr(Input, x);
    for i := 1 to GetItems(Get_Greetings) do if AnsiLowerCase(Wort) = AnsiLowerCase(GetItemNr(Get_Greetings, i)) then Kind := Kind + 'greeting;';
    for i := 1 to GetItems(Get_Bye) do if AnsiLowerCase(Wort) = AnsiLowerCase(GetItemNr(Get_Bye, i)) then Kind := Kind + 'bye;';
  end;
  if (FindIt(Input, 'hast') and FindIt(Input, 'du') and FindIt(Input, 'foto')) or (FindIt(Input, 'hast') and FindIt(Input, 'du') and FindIt(Input, 'pic')) then Kind := Kind + 'picofu;';

  if (FindIt(Input, 'bist') and FindIt(Input, 'allein') and FindIt(Input, 'haus')) then Kind := Kind + 'aloneathome;';
  if FindIt(Input, 'luder') or FindIt(Input, 'hure') or FindIt(Input, 'schlampe') or FindIt(Input, 'nutte') then Kind := Kind + 'ass;';
  if FindIt(Input, 'vergiss es') then Kind := Kind + 'forgetit;';
  if FindIt(Input, 'deutsch?') then Kind := Kind + 'german;';
  if FindIt(Input, 'schlag was vor') then Kind := Kind + 'choosethema;';
  if FindIt(Input, 'lass') and FindIt(Input, 'ber') and FindIt(Input, 'was') and FindIt(Input, 'ander') then Kind := Kind + 'otherthema;';
  if (FindIt(Input, 'willst') and FindIt(Input, 'mich') and FindIt(Input, 'verarschen')) or (FindIt(Input, 'verarschst') and FindIt(Input, 'mich') and FindIt(Input, 'nur')) then Kind := Kind + 'joke;';
  if (FindIt(Input, 'wenn') and FindIt(Input, 'du') and FindIt(Input, 'nich') and FindIt(Input, 'will')) then Kind := Kind + 'dontwant;';
  if FindIt(Input, 'heit du') then Kind := Kind + 'prename;';
  if (FindIt(Input, 'aus') and FindIt(Input, 'welcher') and FindIt(Input, 'stadt')) or ((FindIt(Input, 'woher') or FindIt(Input, 'von wo')) and (FindIt(Input, 'bisse') or FindIt(Input, 'bist') or FindIt(Input, 'kommst'))) or (FindIt(Input, 'woher?')) or (FindIt(Input, 'wo') and (FindIt(Input, 'wohn') or FindIt(Input, 'bist') or FindIt(Input, 'kommst')) and (FindIt(Input, 'du') or FindIt(Input, 'her'))) then Kind := Kind + 'arefrom;';
  if (FindIt(Input, 'beschreib') and FindIt(Input, 'dich') and FindIt(Input, 'mal')) or (FindIt(Input, 'wie') and FindIt(Input, 'siehst') and FindIt(Input, 'aus')) then Kind := Kind + 'describeyou;';
  if (FindIt(Input, 'wie') and FindIt(Input, 'alt') and FindIt(Input, 'bist')) or FindIt(Input, 'alter?') then Kind := Kind + 'age;';
  if FindIt(Input, 'wie gro?') then Kind := Kind + 'size;';
  if FindIt(Input, 'kg?') then Kind := Kind + 'weight;';
  if (FindIt(Input, 'wie') and (FindIt(Input, 'gehts') or FindIt(Input, 'gehts') or FindIt(Input, 'geht`s') or FindIt(Input, 'geht''s') or FindIt(Input, 'geht es dir') or FindIt(Input, 'fhlst'))) or FindIt(Input, 'alles klar?') then Kind := Kind + 'howareyou;';
  if FindIt(Input, ':)') or FindIt(Input, ';)') or FindIt(Input, ';]') or FindIt(Input, ':>') or FindIt(Input, ':-)') or FindIt(Input, ':o)') or FindIt(Input, ';)=') or FindIt(Input, ':)=') then Kind := Kind + 'goodsmily;';
  if (FindIt(Input, 'age') and FindIt(Input, 'sex') and FindIt(Input, 'location')) or FindIt(Input, 'asl?') or FindIt(Input, 'asl ?') or FindIt(Input, 'a,s,l?') or FindIt(Input, 'a,s,l ?') or FindIt(Input, 'asl please') then Kind := Kind + 'asl;';
  if (FindIt(Input, 'ficken') and FindIt(Input, 'mit') and FindIt(Input, 'mir')) or (FindIt(Input, 'willst') and FindIt(Input, 'du') and FindIt(Input, 'ficken')) or FindIt(Input, 'ficken?') then Kind := Kind + 'wannafuck;';
  if (FindIt(Input, 'scheinst') and FindIt(Input, 'nicht') and FindIt(Input, 'hell') and FindIt(Input, 'sein')) or (FindIt(Input, 'bist') and FindIt(Input, 'dumm')) or (FindIt(Input, 'du') and FindIt(Input, 'spinnst'))then Kind := Kind + 'arestupid;';
  if (FindIt(Input, 'nich') and FindIt(Input, 'schlecht')) then Kind := Kind + 'notbad;';
  if FindIt(Input, 'freizeitbeschftigungen?') or FindIt(Input, 'hobbies?') or (FindIt(Input, 'was') and FindIt(Input, 'fr') and FindIt(Input, 'hobbies') and FindIt(Input, 'hast')) or (FindIt(Input, 'was') and FindIt(Input, 'interessiert') and FindIt(Input, 'dich')) or (FindIt(Input, 'was') and FindIt(Input, 'machst') and FindIt(Input, 'in') and FindIt(Input, 'freizeit')) then Kind := Kind + 'hobbies;';
  if ((FindIt(Input, 'wieso') or FindIt(Input, 'warum') or FindIt(Input, 'weshalb')) and (FindIt(Input, 'kapierst') or FindIt(Input, 'verstehst')) and FindIt(Input, 'nich')) or (FindIt(Input, 'was') and FindIt(Input, 'machst') and FindIt(Input, 'in') and FindIt(Input, 'freizeit')) then Kind := Kind + 'whynotunderstand;';
  if ((FindIt(Input, 'chattest') or FindIt(Input, 'bist')) and FindIt(Input, 'oft') and FindIt(Input, 'hier')) then Kind := Kind + 'oftenhere;'; 









  if FindIt(Kind, 'greeting;') then Final := Final + '|' + GetItemNr(Send_Greetings, Random(GetItems(Send_Greetings))+1);
  if FindIt(Kind, 'howareyou;') then Final := Final + '|' + GetItemNr(Send_HowAreYou, Random(GetItems(Send_HowAreYou))+1);
  if FindIt(Kind, 'picofu;') then
    if TransForm('<picture>') = '' then Final := Final + '|' + GetItemNr(Send_NoPic, Random(GetItems(Send_NoPic))+1) else
    begin
      AssignFile(Pic, TransForm('<picture>'));
      Reset(Pic);
      Final := Final + '|' + GetItemNr(Send_YesPic, Random(GetItems(Send_YesPic))+1) + '|' + 'DCC SEND ' + ExtractFileName(TransForm('<picture>')) + ' ' + IntToStr(EncodeIP(MainForm.IRCClient.Socket.LocalAddress)) + ' 5678 ' + IntToStr(FileSize(Pic)) + '';
      CloseFile(Pic);
      MainForm.DCCServer.Active := TRUE;
    end;
  if FindIt(Kind, 'arefrom;') then Final := Final + '|' + GetItemNr(Send_Location, Random(GetItems(Send_Location))+1);
  if FindIt(Kind, 'joke;') then Final := Final + '|' + GetItemNr(Send_NoJoke, Random(GetItems(Send_NoJoke))+1);
  if FindIt(Kind, 'dontwant;') then Final := Final + '|' + GetItemNr(Send_WantTo, Random(GetItems(Send_WantTo))+1);
  if FindIt(Kind, 'age;') then Final := Final + '|' + GetItemNr(Send_Age, Random(GetItems(Send_Age))+1);
  if FindIt(Kind, 'prename;') then Final := Final + '|' + GetItemNr(Send_PreName, Random(GetItems(Send_PreName))+1);
  if FindIt(Kind, 'ass;') then Final := Final + '|' + GetItemNr(Send_WhyAss, Random(GetItems(Send_WhyAss))+1);

  if FindIt(Kind, 'oftenhere;') then Final := Final + '|' + GetItemNr(Send_OftenHere, Random(GetItems(Send_OftenHere))+1);
  if FindIt(Kind, 'aloneathome;') then Final := Final + '|' + GetItemNr(Send_Alone, Random(GetItems(Send_Alone))+1);
  if FindIt(Kind, 'forgetit;') then Final := Final + '|' + GetItemNr(Send_WhyForget, Random(GetItems(Send_WhyForget))+1);
  if FindIt(Kind, 'whynotunderstand;') then Final := Final + '|' + GetItemNr(Send_WhyNotUnderstand, Random(GetItems(Send_WhyNotUnderstand))+1);
  if FindIt(Kind, 'hobbies;') then Final := Final + '|' + GetItemNr(Send_Hobbies, Random(GetItems(Send_Hobbies))+1);
  if FindIt(Kind, 'notbad;') then Final := Final + '|' + GetItemNr(Send_Thx, Random(GetItems(Send_Thx))+1);
  if FindIt(Kind, 'arestupid;') then Final := Final + '|' + GetItemNr(Send_Stupid, Random(GetItems(Send_Stupid))+1);
  if FindIt(Kind, 'german;') then Final := Final + '|' + GetItemNr(Send_Yes, Random(GetItems(Send_Yes))+1);
  if FindIt(Kind, 'choosethema;') then Final := Final + '|' + GetItemNr(Send_Thema, Random(GetItems(Send_Thema))+1);
  if FindIt(Kind, 'otherthema;') then Final := Final + '|' + GetItemNr(Send_Agree, Random(GetItems(Send_Agree))+1);
  if FindIt(Kind, 'wannafuck;') then Final := Final + '|' + GetItemNr(Send_WantFuck, Random(GetItems(Send_WantFuck))+1);
  if FindIt(Kind, 'describeyou;') then Final := Final + '|' + GetItemNr(Send_Description1 + Send_Description2, Random(GetItems(Send_Description1 + Send_Description2))+1);
  if FindIt(Kind, 'size;') then Final := Final + '|' + GetItemNr(Send_Size, Random(GetItems(Send_Size))+1);
  if FindIt(Kind, 'weight;') then Final := Final + '|' + GetItemNr(Send_Weight, Random(GetItems(Send_Weight))+1);
  if FindIt(Kind, 'asl;') then Final := Final + '|' + GetItemNr(Send_asl, Random(GetItems(Send_asl))+1);
  if FindIt(Kind, 'goodsmily;') then Final := Final + '|' + GetItemNr(Smily_Good, Random(GetItems(Smily_Good))+1);
  if FindIt(Kind, 'bye;') then Final := Final + '|' + GetItemNr(Send_Bye, Random(GetItems(Send_Bye))+1);
  if Kind = '' then Final := '|' + GetItemNr(Send_DontUnderstand, Random(GetItems(Send_DontUnderstand))+1);
  Final := TransForm(Final);
  Result := Final;
end;

function Denied(Nick:String):Boolean;
var i: Integer;
begin
  Result := FALSE;
  with MainForm do
  begin
    for i := 0 to DenyListBox.Items.Count-1 do
      if AnsiLowerCase(DenyListBox.Items[i]) = AnsiLowerCase(Nick) then Result := TRUE;
  end;
end;

procedure AddUser(Nick:String);
var i: Integer;
begin
  with MainForm do
  begin
    for i := 0 to DenyListBox.Items.Count-1 do
      if AnsiLowerCase(DenyListBox.Items[i]) = AnsiLowerCase(Nick) then Exit;
    DenyListBox.Items.Add(Nick);
  end;
end;

procedure DelUser(Nick:String);
var i: Integer;
begin
  with MainForm do
  begin
    for i := 0 to DenyListBox.Items.Count-1 do
      if AnsiLowerCase(DenyListBox.Items[i]) = AnsiLowerCase(Nick) then DenyListBox.Items.Delete(i);
  end;
end;

function CountSentences(Index:String):Integer;
var i, Nr: Integer;
begin
  Nr := 0;
  for i := 1 to Length(Index) do
    if Index[i] = '|' then Inc(Nr);
  Result := Nr;
end;

procedure TextReceived(index:String);
var Action_, Target_, FirstCom_, SecondComF_, ThirdComT_, ThirdComF_, Person_, Msg_, CommandoChan, SelfNick, Tmp: String;
    INI: TINIFile;
    CharTime, i: Integer;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  Action_ := GetAction(index);
  Target_ := GetTarget(index);
  FirstCom_ := AnsiLowerCase(GetFirstCom(index));
  SecondComF_ := GetSecondCom(index, FALSE);
  ThirdComT_ := GetThirdCom(index, TRUE);
  ThirdComF_ := GetThirdCom(index, FALSE);
  Person_ := GetPerson(index);
  Msg_ := GetMessage(index);
  CharTime := StrToInt(INI.ReadString('General', 'CharTime', '500'));
  CommandoChan := INI.ReadString('IRC', 'CommandoChannel', '#Laber-B0T');
  SelfNick := INI.ReadString('IRC', 'BotNick', 'Laber-B0T');
  with MainForm do
  begin
    LogMemo.Lines.Add(index);
    if Ping(index) then IRCClient.Socket.SendText(Pong(index));
    if Action_ = '433' then IRCClient.Socket.SendText(LogonText(INI.ReadString('IRC', 'BotNick', '[]B0T[]'), INI.ReadString('PersonData', 'PreName', 'Laber-B0T'), INI.ReadString('PersonData', 'PreName', 'Laber') + ' ' + INI.ReadString('PersonData', 'LastName', 'B0T')));
    if (Action_ = '422') or (Action_ = '376') then
    begin
      IdentServer.Active := FALSE;
      IRCClient.Socket.SendText(JoinChannel(CommandoChan));
      IRCClient.Socket.SendText(SetMode(CommandoChan, '+nt', ''));
      IRCClient.Socket.SendText(SetMode(CommandoChan, '+msi', ''));
      IRCClient.Socket.SendText(SetTopic(CommandoChan, '--] ' + SelfNick + '''s Kommando Channel [----] Laber-B0T (c) 2001 CREEQ [--' ));
    end;
    if Action_ = 'PRIVMSG' then
    begin
{      if Copy(Msg_, 1, 9) = 'DCC SEND' then
        if DCCClient.Active = FALSE then
        begin
          DCCClient.Host := DecodeIP(StrToInt(Copy(GetWordNr(Msg_, 4), 1, 5))*100000 + StrToInt(Copy(GetWordNr(Msg_, 4), 6, 5)));
          DCCClient.Port := StrToInt(GetWordNr(Msg_, 5));
          DCCGet := StrToInt(Copy(GetWordNr(Msg_, 6), 1, Length(GetWordNr(Msg_, 6))-1));
          DCCClient.Active := TRUE;
        end;}
      if AnsiLowerCase(Target_) = AnsiLowerCase(CommandoChan) then
      begin
        if FirstCom_ = '.join' then IRCClient.Socket.SendText(JoinChannel(SecondComF_));
        if FirstCom_ = '.answer' then
        begin
          if AnsiLowerCase(ThirdComF_) = 'on' then
          begin
            IRCClient.Socket.SendText(PrivMsg(CommandoChan, '14Answering for ' + SecondComF_ + ' Enabled'));
            DelUser(SecondComF_);
          end;
          if AnsiLowerCase(ThirdComF_) = 'off' then
          begin
            IRCClient.Socket.SendText(PrivMsg(CommandoChan, '14Answering for ' + SecondComF_ + ' Disabled'));
            AddUser(SecondComF_);
          end;
        end;
        if FirstCom_ = '.say' then
        begin
          IRCClient.Socket.SendText(PrivMsg(SecondComF_, ThirdComT_));
          IRCClient.Socket.SendText(PrivMsg(CommandoChan, '14--> ' + SecondComF_ + ': ' + ThirdComT_));
        end;
        if FirstCom_ = '.info' then IRCClient.Socket.SendText(PrivMsg(CommandoChan, 'Laber-B0T (c) 2001 CREEQ ... Version: ' + Version));
      end;
      if (AnsiLowerCase(Target_) = AnsiLowerCase(SelfNick)) and not (Msg_[1] = '') then
      begin
        IRCClient.Socket.SendText(PrivMsg(CommandoChan, '14<-- ' + Person_ + ': ' + Msg_));
        if not Denied(Person_) then
        begin
          Tmp := Talk(Msg_);
          for i := 1 to CountSentences(Tmp) do
          begin
            Delay(Length(GetSentence(Tmp, i))*CharTime);
            IRCClient.Socket.SendText(PrivMsg(CommandoChan, '14--> ' + Person_ + ': ' + GetSentence(Tmp, i)));
            IRCClient.Socket.SendText(PrivMsg(Person_, GetSentence(Tmp, i)));
          end;
        end;
      end;
    end;
  end;
  INI.Free;
end;

procedure Delay(MSeconds : Longint);
var FTickCount : Longint;
Begin
  FTickCount := GetTickCount;
  Repeat
    Application.ProcessMessages;
  Until ((GetTickCount-FTickCount) >= MSeconds);
end;

procedure TMainForm.OnlineButtonClick(Sender: TObject);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  IRCClient.Port := StrToInt(INI.ReadString('IRC', 'Port', '6667'));
  IRCClient.Host := INI.ReadString('IRC', 'Server', 'irc.freenet.de');
  INI.Free;
  IdentServer.Active := TRUE;
  IRCClient.Active := TRUE;
  OnlineButton.Enabled := FALSE;
  OfflineButton.Enabled := TRUE;
end;

procedure TMainForm.OfflineButtonClick(Sender: TObject);
begin
  IdentServer.Active := FALSE;
  IRCClient.Active := FALSE;
  OnlineButton.Enabled := TRUE;
  OfflineButton.Enabled := FALSE;
end;

function CountComs(Index:String):Integer;
var i, count: Integer;
begin
  Count := 1;
  for i := 1 to Length(Index) do
    if (Index[i] = ' ') or (Index[i] = '.') or (Index[i] = '!') or (Index[i] = '?') or (Index[i] = ',') or (Index[i] = ';') or (Index[i] = ':') or (Index[i] = '(') or (Index[i] = ')') or (Index[i] = '=') or (Index[i] = '*') or (Index[i] = '#') or (Index[i] = '''') or (Index[i] = '+') or (Index[i] = '-') or (Index[i] = '}') or (Index[i] = ']') or (Index[i] = '[') or (Index[i] = '{') or (Index[i] = '&') or (Index[i] = '$') or (Index[i] = '"') or (Index[i] = '^') then Inc(Count);
  Result := Count;
end;

function GetComNr(Index:String;Nr:Integer):String;
var PosA, Pos, i: Integer;
begin
  PosA := 1;
  Pos := 0;
  for i := 1 to Length(Index) do
  begin
    if (Index[i] = ' ') or (Index[i] = '.') or (Index[i] = '!') or (Index[i] = '?') or (Index[i] = ',') or (Index[i] = ';') or (Index[i] = ':') or (Index[i] = '(') or (Index[i] = ')') or (Index[i] = '=') or (Index[i] = '*') or (Index[i] = '#') or (Index[i] = '''') or (Index[i] = '+') or (Index[i] = '-') or (Index[i] = '}') or (Index[i] = ']') or (Index[i] = '[') or (Index[i] = '{') or (Index[i] = '&') or (Index[i] = '$') or (Index[i] = '"') or (Index[i] = '^') then 
    begin
      Inc(Pos);
      if Pos = Nr then
      begin
        Result := Copy(Index, PosA, i-PosA);
      end else PosA := i+1;
    end;
    if i = Length(index) then
    begin
      Inc(Pos);
      if Pos = Nr then
      begin
        Result := Copy(Index, PosA, i-PosA+1);
      end else PosA := i+1;
    end;
  end;
end;

procedure TMainForm.SendEditKeyPress(Sender: TObject; var Key: Char);
var INI: TINIFile;
begin
  if Key = #13 then
  begin
    INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
    if AnsiLowerCase(GetComNr(SendEdit.Text, 1)) = 'op' then
      IRCClient.Socket.SendText(SetMode(INI.ReadString('IRC', 'CommandoChannel', '#Laber-B0T'), '+o', GetComNr(SendEdit.Text, 2)));
    if AnsiLowerCase(GetComNr(SendEdit.Text, 1)) = 'voice' then
      IRCClient.Socket.SendText(SetMode(INI.ReadString('IRC', 'CommandoChannel', '#Laber-B0T'), '+v', GetComNr(SendEdit.Text, 2)));
    if AnsiLowerCase(GetComNr(SendEdit.Text, 1)) = 'kick' then
      IRCClient.Socket.SendText(Kick(INI.ReadString('IRC', 'CommandoChannel', '#Laber-B0T'), GetComNr(SendEdit.Text, 2), 'Have a nice day ...'));
    if AnsiLowerCase(GetComNr(SendEdit.Text, 1)) = 'invite' then
      IRCClient.Socket.SendText(Invite(GetComNr(SendEdit.Text, 2), INI.ReadString('IRC', 'CommandoChannel', '#Laber-B0T')));
    INI.Free;
    SendEdit.Clear;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not (Profile = '') then LogMemo.Lines.SaveToFile(HomeDir + '\PROFILES\' + Profile + '.log');
end;

procedure TMainForm.ServerSendEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    IRCClient.Socket.SendText(ServerCommand(ServerSendEdit.Text));
    ServerSendEdit.Clear;
  end;
end;

procedure TMainForm.DCCClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var GetFile: TextFile;
begin
  AssignFile(GetFile, 'test.jpg');
  Append(GetFile);
  Write(GetFile, DCCClient.Socket.ReceiveText);
  CloseFile(GetFile);
end;

procedure TMainForm.DCCServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var Pic: File of Char;
    Tmp: Char;
begin
  AssignFile(Pic, TransForm('<picture>'));
  Reset(Pic);
  while not EoF(Pic) do
  begin
    Read(Pic, Tmp);
    DCCServer.Socket.Connections[0].SendText(Tmp);
  end;
  CloseFile(Pic);
end;

procedure TMainForm.DCCServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  DCCServer.Active := FALSE;
end;

end.
