unit OptionsForm_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, INIFiles;

type
  TOptionsForm = class(TForm)
    Panel1: TPanel;
    ApplyButton: TButton;
    CancelButton: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    NameEdit: TEdit;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    ServerEdit: TEdit;
    Label3: TLabel;
    PortEdit: TEdit;
    Label4: TLabel;
    NickEdit: TEdit;
    Label5: TLabel;
    IdentEdit: TEdit;
    Label6: TLabel;
    RealNameEdit: TEdit;
    Label7: TLabel;
    CommandChannelEdit: TEdit;
    GroupBox3: TGroupBox;
    Label8: TLabel;
    CharEdit: TEdit;
    Label9: TLabel;
    GroupBox4: TGroupBox;
    DebugModeCheckBox: TCheckBox;
    SaveUnknownReplyCheckBox: TCheckBox;
    Label10: TLabel;
    LocationEdit: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    SizeEdit: TEdit;
    EyeColorEdit: TEdit;
    HairColorEdit: TEdit;
    FigureEdit: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    AgeEdit: TEdit;
    SexRadioGroup: TRadioGroup;
    Label17: TLabel;
    HobbiesEdit: TEdit;
    GroupBox5: TGroupBox;
    PasteQuerysCheckBox: TCheckBox;
    procedure ApplyButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsForm: TOptionsForm;

implementation

uses MainForm_Unit;

{$R *.dfm}

procedure TOptionsForm.ApplyButtonClick(Sender: TObject);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
  INI.WriteString('IRC', 'NickName', NickEdit.Text);
  INI.WriteString('IRC', 'Server', ServerEdit.Text);
  INI.WriteString('IRC', 'Port', PortEdit.Text);
  INI.WriteString('IRC', 'RealName', RealNameEdit.Text);
  INI.WriteString('IRC', 'Ident', IdentEdit.Text);
  INI.WriteString('IRC', 'CommandChannel', CommandChannelEdit.Text);
  INI.WriteString('Person', 'Name', NameEdit.Text);
  INI.WriteString('Person', 'Location', LocationEdit.Text);
  INI.WriteString('Person', 'Size', SizeEdit.Text);
  INI.WriteString('Person', 'EyeColor', EyeColorEdit.Text);
  INI.WriteString('Person', 'HairColor', HairColorEdit.Text);
  INI.WriteString('Person', 'Figure', FigureEdit.Text);
  INI.WriteString('Person', 'Age', AgeEdit.Text);
  INI.WriteString('Person', 'Sex', IntToStr(SexRadioGroup.ItemIndex));
  INI.WriteString('Person', 'Hobbies', HobbiesEdit.Text);
  INI.WriteString('Misc', 'CharTime', CharEdit.Text);
  if DebugModeCheckBox.Checked then INI.WriteString('Debug', 'DebugMode', 'TRUE')
    else INI.WriteString('Debug', 'DebugMode', 'FALSE');
  if SaveUnknownReplyCheckBox.Checked then INI.WriteString('Debug', 'SaveUnknownReply', 'TRUE')
    else INI.WriteString('Debug', 'SaveUnknownReply', 'FALSE');
  if PasteQuerysCheckBox.Checked then INI.WriteString('Command', 'PasteQuerys', 'TRUE')
    else INI.WriteString('Command', 'PasteQuerys', 'FALSE');
  INI.Free;
  Close();
end;

procedure TOptionsForm.FormShow(Sender: TObject);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
  NickEdit.Text := INI.ReadString('IRC', 'NickName', 'LaberBot');
  ServerEdit.Text := INI.ReadString('IRC', 'Server', 'irc.isdnet.fr');
  PortEdit.Text := INI.ReadString('IRC', 'Port', '6667');
  RealNameEdit.Text := INI.ReadString('IRC', 'RealName', 'Laber-B0T' + ' ' + Version);
  IdentEdit.Text := INI.ReadString('IRC', 'Ident', 'LaberB0T');
  CommandChannelEdit.Text := INI.ReadString('IRC', 'CommandChannel', '#Laber-B0T');
  NameEdit.Text := INI.ReadString('Person', 'Name', 'LaberBot');
  LocationEdit.Text := INI.ReadString('Person', 'Location', 'Somewhere');
  SizeEdit.Text := INI.ReadString('Person', 'Size', '1,70');
  EyeColorEdit.Text := INI.ReadString('Person', 'EyeColor', 'blue');
  HairColorEdit.Text := INI.ReadString('Person', 'HairColor', 'black');
  FigureEdit.Text := INI.ReadString('Person', 'Figure', 'fat');
  AgeEdit.Text := INI.ReadString('Person', 'Age', '18');
  SexRadioGroup.ItemIndex := StrToInt(INI.ReadString('Person', 'Sex', '1'));
  HobbiesEdit.Text := INI.ReadString('Person', 'Hobbies', 'nothing');
  CharEdit.Text := INI.ReadString('Misc', 'CharTime', '300');
  if (INI.ReadString('Debug', 'DebugMode', 'FALSE') = 'TRUE') then DebugModeCheckBox.Checked := TRUE
    else DebugModeCheckBox.Checked := FALSE;
  if (INI.ReadString('Debug', 'SaveUnknownReply', 'TRUE') = 'TRUE') then SaveUnknownReplyCheckBox.Checked := TRUE
    else SaveUnknownReplyCheckBox.Checked := FALSE;
  if (INI.ReadString('Command', 'PasteQuerys', 'FALSE') = 'TRUE') then PasteQuerysCheckBox.Checked := TRUE
    else PasteQuerysCheckBox.Checked := FALSE;
  INI.Free;
end;

procedure TOptionsForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

end.
