unit PersonalDataOptionsForm_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, INIFiles;

type
  TPersonDataOptionsForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    PreNameEdit: TEdit;
    Label2: TLabel;
    LastNameEdit: TEdit;
    CancelButton: TButton;
    ApplyButton: TButton;
    GenerateButton: TButton;
    SexRadioGroup: TRadioGroup;
    Label3: TLabel;
    LocationEdit: TEdit;
    Label4: TLabel;
    AgeEdit: TEdit;
    Label5: TLabel;
    HairColorEdit: TEdit;
    Label6: TLabel;
    SizeEdit: TEdit;
    Label7: TLabel;
    FigureEdit: TEdit;
    Label8: TLabel;
    EyeColorEdit: TEdit;
    Label9: TLabel;
    WeightEdit: TEdit;
    PicButton: TButton;
    PicOpenDialog: TOpenDialog;
    Label10: TLabel;
    HobbyEdit: TEdit;
    procedure CancelButtonClick(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GenerateButtonClick(Sender: TObject);
    procedure PicButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

function Generate(What:String):String;

var
  PersonDataOptionsForm: TPersonDataOptionsForm;

implementation

uses MainForm_Unit;

{$R *.dfm}

procedure TPersonDataOptionsForm.CancelButtonClick(Sender: TObject);
begin
  Close();
end;

procedure TPersonDataOptionsForm.ApplyButtonClick(Sender: TObject);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  INI.WriteString('PersonData', 'PreName', PreNameEdit.Text);
  INI.WriteString('PersonData', 'LastName', LastNameEdit.Text);
  INI.WriteString('PersonData', 'Sex', IntToStr(SexRadioGroup.ItemIndex));
  INI.WriteString('PersonData', 'Location', LocationEdit.Text);
  INI.WriteString('PersonData', 'Age', AgeEdit.Text);
  INI.WriteString('PersonData', 'Size', SizeEdit.Text);
  INI.WriteString('PersonData', 'Figure', FigureEdit.Text);
  INI.WriteString('PersonData', 'HairColor', HairColorEdit.Text);
  INI.WriteString('PersonData', 'EyeColor', EyeColorEdit.Text);
  INI.WriteString('PersonData', 'Weight', WeightEdit.Text);
  INI.WriteString('PersonData', 'Picture', PicOpenDialog.FileName);
  INI.WriteString('PersonData', 'Hobbies' , HobbyEdit.Text);
  INI.Free;
  Close();
end;

procedure TPersonDataOptionsForm.FormShow(Sender: TObject);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + '\PROFILES\' + Profile + '.ini');
  PreNameEdit.Text := INI.ReadString('PersonData', 'PreName', 'Laber');
  LastNameEdit.Text := INI.ReadString('PersonData', 'LastName', 'B0T');
  SexRadioGroup.ItemIndex := StrToInt(INI.ReadString('PersonData', 'Sex', '0'));
  LocationEdit.Text := INI.ReadString('PersonData', 'Location', 'IRC');
  AgeEdit.Text := INI.ReadString('PersonData', 'Age', '18');
  SizeEdit.Text := INI.ReadString('PersonData', 'Size', '1,70');
  FigureEdit.Text := INI.ReadString('PersonData', 'Figure', 'schlank');
  HairColorEdit.Text := INI.ReadString('PersonData', 'HairColor', 'blond');
  EyeColorEdit.Text := INI.ReadString('PersonData', 'EyeColor', 'blau');
  WeightEdit.Text := INI.ReadString('PersonData', 'Weight', '65');
  PicOpenDialog.FileName := INI.ReadString('PersonData', 'Picture', '');
  HobbyEdit.Text := INI.ReadString('PersonData', 'Hobbies', 'lesen, tanzen, disco, freunde und compuer');
  INI.Free;
end;

function Generate(What:String):String;
const PreNamesM = 'Frank|Thomas|Peter|Martin|Tom|Max|Dirk|Tobias|Benjamin|Paul|Timm|Mark|Marc';
      PreNamesF = 'Maria|Tanja|Mandy|Alice|Katja|Claudia|Betti|Nancy|Nadine|Kate|Jane|Susi|Jenny|Sandy';
      LastNames = 'Keller|Pranker|Schulz|Meier|Meyer|Kaiser|Kayser|Belz|Schranz|Pehl';
      Locations = 'Mnchen|Frankfurt|Berlin|Hamburg|Bremen|Mainz|Main|Koblenz|Magdeburg|Leipzig|Dsseldorf|Duisburg|Kassel|Aachen|Kln';
      HairColors = 'blond|rot|grn|blau|braun|schwarz|bruinett';
      EyeColors = 'blau|grn|braun|grn-braun|blau-grn';
      Figures = 'schlank|vollschlank|dick|fett|dnn|sehr dnn|gut gebaut';
begin
  Randomize;
  if What = 'PreNameM' then Result := GetItemNr(PreNamesM, Random(GetItems(PreNamesM))+1);
  if What = 'PreNameF' then Result := GetItemNr(PreNamesF, Random(GetItems(PreNamesF))+1);
  if What = 'LastName' then Result := GetItemNr(LastNames, Random(GetItems(LastNames))+1);
  if What = 'Location' then Result := GetItemNr(Locations, Random(GetItems(Locations))+1);
  if What = 'Figure' then Result := GetItemNr(Figures, Random(GetItems(Figures))+1);
  if What = 'HairColor' then Result := GetItemNr(HairColors, Random(GetItems(HairColors))+1);
  if What = 'EyeColor' then Result := GetItemNr(EyeColors, Random(GetItems(EyeColors))+1);
end;

procedure TPersonDataOptionsForm.GenerateButtonClick(Sender: TObject);
begin
  Randomize;
  SexRadioGroup.ItemIndex := Random(2);
  if SexRadioGroup.ItemIndex = 0 then PreNameEdit.Text := Generate('PreNameM');
  if SexRadioGroup.ItemIndex = 1 then PreNameEdit.Text := Generate('PreNameF');
  LastNameEdit.Text := Generate('LastName');
  LocationEdit.Text := Generate('Location');
  AgeEdit.Text := IntToStr(Random(37)+14);
  HairColorEdit.Text := Generate('HairColor');
  EyeColorEdit.Text := Generate('EyeColor');
  SizeEdit.Text := '1,' + IntToStr(Random(31)+65);
  FigureEdit.Text := Generate('Figure');
  WeightEdit.Text := IntToStr(Random(56)+65);
  PicOpenDialog.FileName := '';
  Hobbyedit.Text := 'lesen, tanzen, disco, freunde und compuer';
end;

procedure TPersonDataOptionsForm.PicButtonClick(Sender: TObject);
begin
  PicOpenDialog.InitialDir := HomeDir;
  PicOpenDialog.Execute;
end;

end.
